C
C     GSX-80 DRIVER for MFA Terminal
C     Copyright (C) 2014 by Udo Munk
C     Copyright (C) 2020 by Martin Hepperle
C
C234567890123456789012345678901234567890123456789012345678901234567890123456789
C----vv----------------------------------------------------------------v-------
      SUBROUTINE DDMFA(CONTRL,INTIN,PTSIN,INTOUT,PTSOUT)
      INTEGER CONTRL(1),INTIN(1),PTSIN(1),INTOUT(1),PTSOUT(1)
C
C     VARIABLES
C
      INTEGER I,J,K
      INTEGER OPCODE,INMODE
      LOGICAL PFLAG,OFLAG
      INTEGER LNTP,MKTP
      INTEGER MSIZE
      INTEGER XY(2)
      INTEGER XLO,YLO,XHI,YHI
      INTEGER*1 LINE(20)

      EXTERNAL IGET3, CLAMP
      INTEGER IGET3, CLAMP
C
C     DATA
C
C     FONT SIZES 5x7, 8 multiples
C     CELL SIZES 7x10, 8 multiples
C     PRINT FLAG FOR DRIVER COPYRIGHT AND VERSION TEXT
      DATA PFLAG /.FALSE./
C     WORKSTATION OPEN FLAG
      DATA OFLAG /.FALSE./
C     MARKER SIZE 6 and up
      DATA MSIZE/6/
C
C     INITIALIZATION
C
      CONTRL(3) = 0
      CONTRL(5) = 0
      OPCODE = CONTRL(1)

C     DONT DRAW ON CLOSED WOKSTATION
      IF (OFLAG .NE. .TRUE. .AND. OPCODE .NE. 1) RETURN

C
C     DISPATCH ON OPCODE
C
      GOTO(1100,1200,1300,1400,1500,1600,1700,1800,1900,2000,
     1     2100,2200,2300,2400,2500,2600,2700,2800,2900,3000,
     2     3100,3200,3300,3400,3500,3600,3700,3800,3900,4000,
     3     4100,4200,4300),OPCODE
      RETURN

C
C     OPCODE OPEN WORKSTATION
C
1100  IF (PFLAG .NE. .FALSE.) GOTO 1110
      CALL MFAVER
      PFLAG = .TRUE.
1110  CONTRL(3) = 6
      CONTRL(5) = 45
      LNTP = CLAMP(INTIN(2),1,9)
      MKTP = CLAMP(INTIN(4),1,6)
      INTOUT(1) = 480-1
      INTOUT(2) = 432-1
      INTOUT(3) = 1
      INTOUT(4) = 252
      INTOUT(5) = 252
C     character sizes
      INTOUT(6) = 1
C     line types:
      INTOUT(7) = 1
      INTOUT(8) = 1
C     marker types
      INTOUT(9) = 5
      INTOUT(10) = 4
      INTOUT(11) = 1
      INTOUT(12) = 0
      INTOUT(13) = 0
      INTOUT(14) = 2
      INTOUT(15) = 0
      INTOUT(16) = -1
      INTOUT(17) = -1
      INTOUT(18) = -1
      INTOUT(19) = -1
      INTOUT(20) = -1
      INTOUT(21) = -1
      INTOUT(22) = -1
      INTOUT(23) = -1
      INTOUT(24) = -1
      INTOUT(25) = -1
      INTOUT(26) = -1
      INTOUT(27) = -1
      INTOUT(28) = -1
      INTOUT(29) = -1
      INTOUT(30) = -1
      INTOUT(31) = -1
      INTOUT(32) = -1
      INTOUT(33) = -1
      INTOUT(34) = -1
      INTOUT(35) = -1
      INTOUT(36) = 0
C     text rotation capability
      INTOUT(37) = 0
      INTOUT(38) = 0
      INTOUT(39) = 0
      INTOUT(40) = 2
C     locator devices
      INTOUT(41) = 0
      INTOUT(42) = 0
      INTOUT(43) = 0
      INTOUT(44) = 1
C     workstation type
      INTOUT(45) = 2
      PTSOUT(1) = 0
      PTSOUT(2) = 1*7
      PTSOUT(3) = 0
      PTSOUT(4) = 2*7
      PTSOUT(5) = 1
      PTSOUT(6) = 0
      PTSOUT(7) = 1
      PTSOUT(8) = 0
      PTSOUT(9) = 0
      PTSOUT(10) = 8
      PTSOUT(11) = 0
      PTSOUT(12) = 32
      OFLAG = .TRUE.
      CALL MFAINI
      RETURN

C
C     OPCODE CLOSE WORKSTATION
C
1200  CONTINUE
      OFLAG = .FALSE.
      RETURN

C
C     OPCODE CLEAR WORKSTATION
C
C     clear grapics
1300  CALL ESC('[2J',3)
      RETURN

C
C     OPCODE UPDATE WORKSTATION
C
1400  RETURN

C
C     OPCODE ESCAPE
C
1500  OPCODE = CONTRL(6)
C     DISPATCH ON FUNCTION
      GOTO(1501,1502,1503,1504,1505,1506,1507,1508,1509,1510,
     1     1511,1512,1513,1514),OPCODE
      RETURN
C     INQUIRE ADDRESSABLE CHARACTER CELLS
1501  INTOUT(1) = 80
      INTOUT(2) = 36
      RETURN

C     ENTER GRAPHICS MODE
1502  CALL MFAINI
      RETURN

C     EXIT GRAPHICS MODE
1503  CALL MFAEXI
      RETURN

C     CURSOR UP     Esc [A
1504  CALL ESC('[A',2)
      RETURN
C     CURSOR DOWN   Esc [B
1505  CALL ESC('[B',2)
      RETURN
C     CURSOR RIGHT  Esc [C
1506  CALL ESC('[C',2)
      RETURN
C     CURSOR LEFT   Esc [D
1507  CALL ESC('[D',2)
      RETURN
C     HOME CURSOR
1508  CALL ESC('[H',2)
      RETURN
C     ERASE TO END OF SCREEN
1509  CALL ESC('[0J',3)
      RETURN
C     ERASE TO END OF LINE
1510  CALL ESC('[0K',3)
      RETURN
C     DIRECT CURSOR ADDRESS
C     Esc & a 12 r 04 C == row and column
1511  CALL ESC('[',1)
      I = CLAMP(INTIN(1),1,34)
      CALL OUTNUM(I)
      CALL MFAOUT(';')
      I = CLAMP(INTIN(2),1,80)
      CALL OUTNUM(I)
      CALL MFAOUT('H')
      RETURN
C     OUTPUT CURSOR ADDRESSABLE TEXT
1512  CONTINUE
      CALL MFASTR(CONTRL(4),INTIN)
      RETURN
C     REVERSE VIDEO ON
C     Esc & d B == inverse
1513  CALL ESC('[7m',3)
      RETURN
C     REVERSE VIDEO OFF
1514  CALL ESC('[0m',3)
      RETURN

C
C     OPCODE POLYLINE
C
1600  CONTINUE
      J = CONTRL(2)-1
      K = 1
      DO 1601 I=1,J
         CALL ESC('[Z1',3)
         CALL XYPAIR(PTSIN(K),PTSIN(K+1))
         CALL XYPAIR(PTSIN(K+2),PTSIN(K+3))
         CALL MFAOUT('Z')
         K = K + 2
1601  CONTINUE
      RETURN

C
C     7: OPCODE POLYMARKER
C
1700  CONTINUE
      K = CONTRL(2)
      J = 1
      DO 1701 I=1,K
      XY(1) = PTSIN(J)
      XY(2) = PTSIN(J+1)
      CALL MPLOT(XY,MKTP,MSIZE)
      J = J + 2
1701  CONTINUE
      RETURN

C
C     8: OPCODE TEXT
C
1800  CONTINUE
      CALL ESC('[Z6',3)
      CALL XYPAIR(PTSIN(1),PTSIN(2))
      CALL MFAOUT(';')
      CALL MFASTR(CONTRL(4),INTIN)
      CALL MFAOUT(3)
      RETURN

C
C     9: OPCODE FILLED AREA
C
1900  CONTINUE
      J = CONTRL(2)-1
      K = 1
      DO 1901 I=1,J
         CALL ESC('[Z1',3)
         CALL XYPAIR(PTSIN(K),PTSIN(K+1))
         CALL XYPAIR(PTSIN(K+2),PTSIN(K+3))
         CALL MFAOUT('Z')
         K = K + 2
1901  CONTINUE
      RETURN

C
C     10: OPCODE CELL ARRAY
C
2000  CONTINUE
C     CALL MFAOUT(29)
C     CALL MFAOUT(27)
C     CALL MFAOUT(96)
      XLO = PTSIN(1)
      XHI = PTSIN(2)
      XHI = PTSIN(3)
      YHI = PTSIN(4)
C     CALL XYPAIR(XLO,YLO)
C     CALL XYPAIR(XHI,YLO)
C     CALL XYPAIR(XHI,YHI)
C      CALL XYPAIR(XLO,YLO)
C      CALL MFAOUT(27)
C      CALL MFAOUT(LNTP+95)
C      CALL MFAOUT(31)
      RETURN

C
C     OPCODE GENERALZED DRAWING PRIMITIVE
C
2100  RETURN

C
C     OPCODE SET CHARACTER HEIGHT
C
2200  I = PTSIN(2)
      J = MAX0(1,(I+4)/7)

C      CALL ESC('*m',2)
C      CALL OUTNUM(J)
C      CALL MFAOUT('M')

      CONTRL(3) = 2
      PTSOUT(1) = J*5
      PTSOUT(2) = J*7
      PTSOUT(3) = J*7
      PTSOUT(4) = J*10
      RETURN

C
C     OPCODE SET CHARACTER UP VECTOR
C
2300  J = INTIN(1)
      IF(J.LT.0)    J=J+3600
      IF(J.GE.3600) J=J-3600
      J = 1 + J/900
C      CALL ESC('*m',2)
C      CALL OUTNUM(J)
C      CALL MFAOUT('N')
      INTOUT(1) = (J-1)*900
      CONTRL(5) = 1
      RETURN

C
C     OPCODE SET COLOR REPRESENTATION
C
2400  CONTINUE
      RETURN

C
C     OPCODE SET POLYLINE LINETYPE
C
2500  LNTP = CLAMP(INTIN(1),1,9)
      IF (LNTP.GE.2) LNTP = LNTP+2
      INTOUT(1) = LNTP
C      CALL ESC('*m',2)
C      CALL OUTNUM(LNTP)
C      CALL MFAOUT('B')
      RETURN

C
C     OPCODE SET POLYLINE WIDTH
C
2600  CONTRL(3) = 1
      PTSOUT(1) = 1
      PTSOUT(2) = 0
      RETURN

C
C     OPCODE SET POLYLINE COLOR INDEX
C
2700  INTOUT(1) = 1
      RETURN

C
C     OPCODE SET POLYMARKER TYPE
C
2800  MKTP = CLAMP(INTIN(1),1,6)
      INTOUT(1) = MKTP
      RETURN

C
C     19: OPCODE SET POLYMARKER SCALE
C
2900  MSIZE = MAX0(6,PTSIN(2))
      CONTRL(3) = 1
      PTSOUT(1) = 0
      PTSOUT(2) = MSIZE
      RETURN

C
C     OPCODE SET POLYMARKER COLOR INDEX
C
3000  INTOUT(1) = 1
      RETURN

C
C     OPCODE SET TEXT FONT
C
3100  INTOUT(1) = 1
      RETURN

C
C     OPCODE SET TEXT COLOR INDEX
C
3200  INTOUT(1) = 1
      RETURN

C
C     OPCODE SET FILL INTERIOR STYLE
C
3300  INTOUT(1) = 0
      RETURN

C
C     OPCODE SET FILL STYLE INDEX
C
3400  INTOUT(1) = 1
      RETURN

C
C     OPCODE SET FILL COLOR INDEX
C
3500  INTOUT(1) = 1
      RETURN

C
C     OPCODE INQUIRE COLOR REPRESENTATION
C
3600  INTOUT(1) = INTIN(1)
      INTOUT(2) = 0
      INTOUT(3) = 0
      INTOUT(4) = 0
      RETURN

C
C     OPCODE INQUIRE CELL ARRAY
C
3700  CONTRL(8) = 0
      CONTRL(9) = 0
      CONTRL(10) = 1
      RETURN

C
C     OPCODE INPUT LOCATOR
C
3800  CONTINUE
      INTOUT(1) = 0
      RETURN

C
C     OPCODE INPUT VALUATOR
C
3900  CONTRL(5) = 0
      RETURN

C
C     OPCODE INPUT CHOICE
C
4000  CONTRL(5) = 0
      RETURN

C
C     OPCODE INPUT STRING
C
4100  RETURN

C
C     OPCODE SET WRITING MODE
C
4200  INTOUT(1) = 2
      RETURN

C
C     OPCODE SET INPUT MODE
C
4300  INMODE = INTIN(2)
      INTOUT(1) = INMODE
      RETURN

      END

      SUBROUTINE MFAINI
C     34 lines
      CALL ESC('[?9l',4)
C     clear
      CALL ESC('[2J',3)
      RETURN
      END

      SUBROUTINE MFAEXI
      RETURN
      END

C
C     CONVERT XY COORDINATES TO ";X;Y" AND OUTPUT
C
      SUBROUTINE XYPAIR(X,Y)
      INTEGER X,Y

      CALL MFAOUT(';')
      CALL OUTNUM(X)
      CALL MFAOUT(';')
C     (0,0) in upper left
      CALL OUTNUM(431-Y)

      RETURN

      END

C
C     Draw a marker at the location given in [INITIN(1),INITIN(2)]
C
      SUBROUTINE MPLOT(INTIN,TYPE,PMSC)
      INTEGER INTIN(2),TYPE,PMSC

      INTEGER X1,X2,Y1,Y2
      INTEGER X3,X4,Y3,Y4
      INTEGER RXY1,RXY2

C     bounding box
      X1 = INTIN(1) - PMSC/2
      X2 = X1 + PMSC
      Y1 = INTIN(2) - PMSC/2
      Y2 = Y1 + PMSC

C     test bounding box
      IF (MIN0(X1,Y1).LT.0 .OR. MAX0(X2,Y2).GT.32767) RETURN

C     for 'x' and '*' approx. PMSC*COS(PI/4)
      RXY1 = PMSC/3 + PMSC/50
      X3 = INTIN(1) - RXY1
      X4 = INTIN(1) + RXY1
      Y3 = INTIN(2) - RXY1
      Y4 = INTIN(2) + RXY1


      IF (TYPE.EQ.1 .OR. TYPE.EQ.4 .OR. TYPE.EQ.6) GOTO 5040
      IF (TYPE.EQ.3 .OR. TYPE.EQ.5) GOTO 5020
C     TYPE .EQ. 2 or invalid
      GOTO 5035

C     3,5: 'x'
5020  CONTINUE
      CALL ESC('[Z1',3)
      CALL XYPAIR(X3,Y3)
      CALL XYPAIR(X4,Y4)
      CALL MFAOUT('Z')
      CALL ESC('[Z1',3)
      CALL XYPAIR(X3,Y4)
      CALL XYPAIR(X4,Y3)
      IF (TYPE.EQ.5) GOTO 5060
      CALL MFAOUT('Z')
C     2,3: '+'
5035  CONTINUE
      X3 = X1 + PMSC/2
      Y3 = Y1 + PMSC/2
      CALL ESC('[Z1',3)
      CALL XYPAIR(X3,Y1)
      CALL XYPAIR(X3,Y2)
      CALL MFAOUT('Z')
      RXY1 = X1 + PMSC/2
      CALL ESC('[Z1',3)
      CALL XYPAIR(X1,Y3)
      CALL XYPAIR(X2,Y3)
      GOTO 5060

C     1,4,6: dot = small x
5040  CONTINUE
      X3 = X1 + PMSC/2 - 30
      Y3 = Y1 + PMSC/2 - 30
      X4 = X3 + 60
      Y4 = Y3 + 60
      CALL ESC('[Z1',3)
      CALL XYPAIR(X3,Y3)
      CALL XYPAIR(X4,Y4)
      CALL MFAOUT('Z')
      CALL ESC('[Z1',3)
      CALL XYPAIR(X3,Y4)
      CALL XYPAIR(X4,Y3)
      IF (TYPE.EQ.1) GOTO 5060
      CALL MFAOUT('Z')
      IF (TYPE.EQ.6) GOTO 5050
C     4: fall through
C     4: square with dot
5045  CONTINUE
      CALL ESC('[Z1',3)
      CALL XYPAIR(X1,Y1)
      CALL XYPAIR(X2,Y1)
      CALL MFAOUT('Z')
      CALL ESC('[Z1',3)
      CALL XYPAIR(X2,Y1)
      CALL XYPAIR(X2,Y2)
      CALL MFAOUT('Z')
      CALL ESC('[Z1',3)
      CALL XYPAIR(X2,Y2)
      CALL XYPAIR(X1,Y2)
      CALL MFAOUT('Z')
      CALL ESC('[Z1',3)
      CALL XYPAIR(X1,Y2)
      CALL XYPAIR(X1,Y1)
      GOTO 5060

C     6: diamond with dot
5050  CONTINUE
      X3 = X1 + PMSC/2
      Y3 = Y1 + PMSC/2
      CALL ESC('[Z1',3)
      CALL XYPAIR(X1,Y3)
      CALL XYPAIR(X3,Y2)
      CALL MFAOUT('Z')
      CALL ESC('[Z1',3)
      CALL XYPAIR(X3,Y2)
      CALL XYPAIR(X2,Y3)
      CALL MFAOUT('Z')
      CALL ESC('[Z1',3)
      CALL XYPAIR(X2,Y3)
      CALL XYPAIR(X3,Y1)
      CALL MFAOUT('Z')
      CALL ESC('[Z1',3)
      CALL XYPAIR(X3,Y1)
      CALL XYPAIR(X1,Y3)

5060  CALL MFAOUT('Z')
      RETURN

      END
C
C     Parse 3 digits from character array, starting at I
C
      INTEGER FUNCTION IGET3(LINE,I)
      INTEGER*1 LINE(20)
      INTEGER I
      IGET3 = (LINE(I) -48)*100 +
     1        (LINE(I+1) -48)*10  +
     2         LINE(I+2) -48
      RETURN
      END
C
C     OUTPUT Esc, C(1...N)
C
      SUBROUTINE ESC(C,N)
      INTEGER*1 C(80)
      INTEGER N
      CALL MFAOUT(27)
      DO 100 I=1,N
      CALL MFAOUT(C(I))
100   CONTINUE
      RETURN
      END
C
C     OUTPUT 1 TO 3 DIGIT DECIMAL NUMBER IN ASCII
C
      SUBROUTINE OUTNUM(I)
      INTEGER I,J,K

      K = I
      IF (K.LT.10) GOTO 10
      IF (K.LT.100) GOTO 100
      IF (K.LT.1000) GOTO 1000
      RETURN

1000  J = K/100
      CALL MFAOUT(J+48)
      K = K - J*100 

100   J = K/10
      CALL MFAOUT(J+48)
      K = K - J*10

10    J = K
      CALL MFAOUT(J+48)
      RETURN

      END

C
C     Limit I to the range LO...HI
C
      INTEGER FUNCTION CLAMP ( I, LO, HI )
      INTEGER I,LO,HI

      IF ( I .LT. LO ) GOTO 100
      IF ( I .GT. HI ) GOTO 200

      CLAMP = I
      RETURN

100   CLAMP = LO
      RETURN

200   CLAMP = HI
      RETURN

      END
